<template>
  <template v-if="isFeatureEnabled">
    <span class="forgot-password-entry">
      {{ $t("forgot") }}
      <span class="forgot-password-entry-link" @click="isShown = true">{{
        $t("password")
      }}</span>?
    </span>
    <el-dialog
      v-model="isShown"
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="forgot-password-modal"
      :fullscreen="fullscreen"
      :append-to-body="fullscreen"
    >
      <div class="forgot-password-modal__header">
        <button class="forgot-password-modal__btn" @click.prevent="closeModal">
          <font-awesome-icon
            icon="circle-xmark"
            class="forgot-password-modal__close"
          />
        </button>
      </div>
      <auth-forgot-password-form
        @on-success="onSuccess"
        @on-login-click="closeModal"
      />
    </el-dialog>
  </template>
</template>

<script setup lang="ts">
import { ref, onMounted } from "vue";
import commonHelper from "@/utils/commonHelper";

const props = defineProps({
  fullscreen: {
    type: Boolean,
    required: false,
    default: false,
  },
  closeOnSuccess: {
    type: Boolean,
    required: false,
    default: true,
  },
});
const isFeatureEnabled = ref<boolean>(false);
const isShown = ref<boolean>(false);
const closeModal = () => {
  isShown.value = false;
};

const onSuccess = () => {
  if (props.closeOnSuccess) {
    setTimeout(() => {
      closeModal();
    }, 3000);
  }
};

watch(
  () => isShown.value,
  () => {
    const sidebar: HTMLElement | null = document.querySelector(
      'div[layout="modern"] aside.el-aside'
    );

    if (!sidebar) return;
    if (isShown.value) {
      sidebar.style.opacity = "0";
      sidebar.style.pointerEvents = "none";
      return;
    }
    sidebar.style.opacity = "1";
    sidebar.style.pointerEvents = "all";
  }
);

const ShouldShow = async () => {
  const response = await commonHelper.getCustomerSettingById(
    "IsForgetPasswordEnabled"
  );
  isFeatureEnabled.value = response && response.Value === "Y";
};

onMounted(() => {
  ShouldShow();
});
</script>

<style lang="scss">
.forgot-password-modal__header {
  display: flex;
  flex-direction: row;
  justify-content: flex-end;
  align-items: center;
  padding: 10px;
  gap: 10px;
  width: 100%;
  height: 40px;
}
.forgot-password-modal__btn {
  position: absolute;
  top: 2%;
  right: 2%;
}
.forgot-password-modal__close {
  width: 24px;
  height: 24px;
  color: var(--primary);
}

.forgot-password-modal {
  background: var(--background5);
  --el-dialog-bg-color: var(--background5);
  width: 480px;
  height: 416px;
  border-radius: 8px;
  display: flex;
  justify-content: center;
  align-items: center;
  outline: none;

  .el-dialog__header {
    display: none;
  }

  .el-dialog__body {
    padding: 0;
  }
}
.is-fullscreen.forgot-password-modal {
  max-width: 100%;
  border-radius: 0;
  position: fixed;
}
.forgot-password-entry {
  color: var(--text5);
  cursor: default;
  font-size: 12px;
}
.forgot-password-entry-link,
.join-now-entry-link {
  color: var(--primary);
  text-decoration: underline;
  cursor: pointer;
  font-weight: bold;
}
</style>
